vlib work
vmap work work

set testbench "spi_master"

if {$argc >= 1} {
    switch $1 {
        "master" {set testbench "spi_master"}
        "slave"  {set testbench "spi_slave"}
        default  {set testbench "spi_master"}
    }
}

# compile design
if {$testbench == "spi_master"} {
    vcom -work work ../src/spi_master.vhd
} else {
    vcom -work work ../src/${testbench}.vhd
}

# compile testbench
vcom -2008 -work work ../src_tb/${testbench}_tb.vhd

# run sim
if {$argc >= 2} {
    vsim -novopt work.${testbench}_tb -GN_TRANSMISSIONS=$2
} else {
    vsim -novopt work.${testbench}_tb -GN_TRANSMISSIONS=1
}

add wave -divider tb
add wave clk_s
add wave rst_s
add wave -expand -group sti *_sti
add wave -expand -group obs *_obs
add wave -group all *
add wave -divider dut
add wave -group dut dut/*

configure wave -namecolwidth 200
configure wave -valuecolwidth 100
config wave -signalnamewidth 1

run -all

wave zoom full