-------------------------------------------------------------------------------
-- HEIG-VD, Haute Ecole d'Ingenierie et de Gestion du canton de Vaud
-- Institut REDS, Reconfigurable & Embedded Digital Systems
--
-- Fichier      : spi_slave_tb.vhd
--
-- Description  : SPI slave interface testbench
--
-- Auteur       :
-- Date         :
-- Version      :
--
--
--| Modifications |------------------------------------------------------------
-- Version   Auteur Date               Description
--
-------------------------------------------------------------------------------

entity spi_slave_tb is
  generic ( N_TRANSMISSIONS : integer := 1);
end spi_slave_tb;

architecture testbench of spi_slave_tb is

    component spi_slave is
        generic(
            N : integer := 8 );
        port (
            clk_i                       : in  std_logic;
            rst_i                       : in  std_logic;
            tx_load_i                   : in  std_logic;
            tx_end_o                    : out std_logic;
            data_parallel_i             : in  std_logic_vector(N-1 downto 0);
            data_parallel_o             : out std_logic_vector(N-1 downto 0);
            sclk_i                      : in  std_logic;
            n_ss_i                      : in  std_logic;
            mosi_i                      : in  std_logic;
            miso_o                      : out std_logic);
    end component;

    constant N : integer := 8;

    signal clk_s             : std_logic;
    signal rst_s             : std_logic;
    signal tx_load_sti       : std_logic;
    signal tx_end_obs        : std_logic;
    signal data_parallel_sti : std_logic_vector(N-1 downto 0);
    signal data_parallel_obs : std_logic_vector(N-1 downto 0);
    signal sclk_sti          : std_logic;
    signal n_ss_sti          : std_logic;
    signal mosi_sti          : std_logic;
    signal miso_obs          : std_logic;

begin

    dut : spi_slave
      generic map
      (
        N => N
      )
      port map
      (
        clk_i           => clk_s,
        rst_i           => rst_s,
        tx_load_i       => tx_load_sti,
        tx_end_o        => tx_end_obs,
        data_parallel_i => data_parallel_sti,
        data_parallel_o => data_parallel_obs,
        sclk_i          => sclk_sti,
        n_ss_i          => n_ss_sti,
        mosi_i          => mosi_sti,
        miso_o          => miso_obs
      );

end tesbench;
